unit Setsize;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, SysUtils, Dialogs;

type
  TSetSizeDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    BSize: TEdit;
    Label1: TLabel;
    procedure EnterCurrentSize(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure EnableMain(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetSizeDlg: TSetSizeDlg;

implementation

uses Unit1;

{$R *.DFM}

procedure TSetSizeDlg.EnterCurrentSize(Sender: TObject);
begin
  SetSizeDlg.BSize.Text := IntToStr (be.nTiles);
  BSize.SetFocus;
  BSize.SelectAll;
  Form1.Enabled := False;
end;

procedure TSetSizeDlg.OKBtnClick(Sender: TObject);
  var s: Integer;
      ix, iy, xx, yy, i , j: Byte;
begin
  try
    s := StrToInt (SetSizeDlg.BSize.Text);
    MinMaxBoard (ix, iy, xx, yy);
    if (xx > yy) then ix := xx else ix := yy;
    Inc (ix);
    if (s < ix) or (s > 25) then
      MessageDlg ( 'Size must be between ' + IntToStr (ix)
                 + ' and 25.',
                 mtError, [mbOk], 0)
    else begin
      be.nTiles := s;
      Close;
      Form1.RedrawBoard (Sender);
      UndoInfo;
    end;
  except
    on EConvertError do
      MessageDlg ('Not a valid integer value.', mtError, [mbOk], 0);
  end;
end;

procedure TSetSizeDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TSetSizeDlg.EnableMain(Sender: TObject;
  var Action: TCloseAction);
begin
  Form1.Enabled := True;
end;

end.
